-- Our Enemy class
require ('luascripts/middleclass')

 Enemy = class('Enemy')

 function temps()
	Enemy:checkForPlayer()
end

 function Enemy:initialize(enemyType,enemyImage,enemyWidth,enemyHeight,enemyFacing,enemySpeed,enemyTileX,enemyTileY)
	--public vars
	self.cron = require 'luascripts/cron'
	
	self.type = enemyType -- can be used later for things like insect,human ect...
	self.image = love.graphics.newImage("images/".. enemyImage)
	self.imageName = enemyImage
	self.width = enemyWidth 
	self.height = enemyHeight
	self.x = 0
	self.y = 0
	self.facing = enemyFacing
	self.animating = false
	self.speed = enemySpeed or 150
	self.tileX = enemyTileX or 0
	self.tileY = enemyTileY or 0

	self.noWalk = false
	Enemy:setTileX(self.tileX)
	Enemy:setTileY(self.tileY)
	Enemy:setFacing(self.facing)
	
	self.id = self.cron.every(1, temps)
	--private vars
	self._anim8 = require ('luascripts/anim8')
	self._g =  self._anim8.newGrid(self.width, self.height, self.image:getWidth(), self.image:getHeight())
	self._animation = self._anim8.newAnimation('loop', self._g('1-3,1'), 0.1)
end

--- getters and setters ---
 function Enemy:setEnemyType(paramType)
	self.type = paramType
end
 function Enemy:getEnemyType()
	return self.type
end

 function Enemy:setImage(paramImage)
	self.image = love.graphics.newImage("images/".. paramImage)
end
 function Enemy:getImage()
	return self.image	
end

 function Enemy:getnoWalk()
	return self.noWalk
end

 function Enemy:setFacing(paramFacing)
	self.facing = paramFacing
end
 function Enemy:getFacing()
	return self.facing
end

 function Enemy:setSpeed(paramSpeed)
	self.speed = paramSpeed
end
 function Enemy:getSpeed()
	return self.speed
end

 function Enemy:setX(paramX)
	self.x = paramX
end
 function Enemy:getX()
	return self.x	
end

 function Enemy:setY(paramY)
	self.y = paramY
end
 function Enemy:getY()
	return self.y	
end

 function Enemy:setTileX(paramTileX)
	self.tileX = paramTileX
end
 function Enemy:getTileX()
	return self.tileX
end

 function Enemy:setTileY(paramTileY)
	self.tileY = paramTileY
end
 function Enemy:getTileY()
	return self.tileY
end
--- end of getters and setters ---

--this will turn animations on or off
 function Enemy:animate(paramAnimate)
	self.animate = paramAnimate
end

--sets Enemy location on the map  
  function Enemy:Location(Px,Py,paramFacing)
	Enemy:setFacing(paramFacing)
	
	self.tileX = Px
	self.tileY = Py
	--32 is tile size
	self.x = self.tileX * 32
	self.y = self.tileY * 32
	Enemy:setTileX(self.tileX)
	Enemy:setTileY(self.tileY)
	Enemy:setFacing(paramFacing)
end

--moves the enemy to the tile if it can might add a return false so you can error fix
 function Enemy:moveTile(x,y)

	-- Grab the tile
	 tile = global.layer.tileData(self.tileX + x, self.tileY + y)

	-- If the tile doesn't exist or is an obstacle then exit the function
	if tile == nil then return end
	if tile.properties.obstacle then return end
	-- Otherwise change the guy's tile
	self.tileX = self.tileX + x
	self.tileY = self.tileY + y

end

 function Enemy:checkTile(x,y)
	-- Grab the tile
	 tile = global.layer.tileData(tileX+x, tileY+y)
	
	-- If the tile doesn't exist or is an obstacle then exit the function
	if tile == nil then 
	self.noWalk = true 
	return 
	end
	
	if tile.properties.obstacle then 
	self.noWalk = true 
	return 
	end
	
	self.noWalk = false
end

--might want to rename this to setAnimation
 function Enemy:setDirection(parmDirection,paramAnimation)
	
	Enemy:setFacing(parmDirection)
	if paramAnimation =="walk" then
	--	Enemy:setImage(self.imageName)
				
		if 	 	self.facing == "up" then	self._animation = self._anim8.newAnimation('loop', self._g('1-3,1'), 0.1)
		elseif  self.facing  == "left" then self._animation = self._anim8.newAnimation('loop', self._g('1-3,2'), 0.1)
		elseif  self.facing  == "down" then self._animation = self._anim8.newAnimation('loop', self._g('1-3,3'), 0.1)
		elseif  self.facing  == "right" then self._animation = self._anim8.newAnimation('loop', self._g('1-3,4'), 0.1)
		end
	 end
	if paramAnimation =="stand" then
	--	Enemy:setImage(self.imageName)
		if 	 	self.facing == "up" then	self._animation = self._anim8.newAnimation('loop', self._g('1-3,1'), 0.1)
		elseif  self.facing  == "left" then self._animation = self._anim8.newAnimation('loop', self._g('1-3,2'), 0.1)
		elseif  self.facing  == "down" then self._animation = self._anim8.newAnimation('loop', self._g('1-3,3'), 0.1)
		elseif  self.facing  == "right" then self._animation = self._anim8.newAnimation('loop', self._g('1-3,4'), 0.1)
		end
	 end

		
end

 function Enemy:checkForPlayer()
		
	local tempX = 0
	local tempY = 0
	
	if 	 	Enemy:getFacing() == "up" then		tempY = -1
	elseif  Enemy:getFacing()  == "down" then 	tempY = 1
	elseif  Enemy:getFacing()  == "left" then	tempX = -1
	elseif  Enemy:getFacing()  == "right" then 	tempX = 1
	end
				
		if	player.getTileX() ==  	Enemy:getTileX() + tempX and player.getTileY()  ==  Enemy:getTileY()+ tempY  then
		--iif	player.getTileX() ==  	self.tileX + tempX and player.getTileY()  == self.tileY + tempY  then
			global.player_Health = global.player_Health - 1
		else 
			global.player_Health = 10
		end
		
end

 function Enemy:update(dt)
	self.cron.update(dt)
	--updates the animation
	self._animation:update(dt)
end

 function Enemy:draw()
	self._animation:draw(self.image, self.x, self.y )
end

return Enemy