-- Our player class
require ('luascripts/middleclass')

Player = class('Player')

function Player:initialize(playerType,playersImage,playerWidth,playerHeight,playerFacing,playerSpeed,playerTileX,playerTileY ,playerX, playerY)
	
		--public vars
	self.type = playerType -- can be used later for things like insect,human ect...
	self.playerImage = love.graphics.newImage("images/".. playersImage) 
	self.playerImageName = playersImage
	self.width =  64
	self.height =  64
	self.x = playerX or global.startX
	self.y = playerY or global.startY
	self.tileX = global.startTileX 
	self.tileY = global.startTileY 
	self.facing = playerFacing
	self.animating = false
	self.speed = playerSpeed or 150
	self.noWalk = false
	self.up = false
	self.down = false
	self.left = false
	self.right = false
	
	
	
	--private vars
	self._playerAnim8 = 		require ('luascripts/anim8')
	self._playerG =  		self._playerAnim8.newGrid(64, 64, self.playerImage:getWidth(), self.playerImage:getHeight())
	self._playerAnimation = 	self._playerAnim8.newAnimation('loop', self._playerG('2-9,1'), 0.1)

	self.playerImageName = "male_walkcycle.png"
	Player:setImage(self.playerImageName)
	--Player:setDirection("up","stand")

end

--- getters and setters ---
function Player:setEnemyType(paramType)
	self.type = paramType
end
function Player:getEnemyType()
	return self.type
end

function Player:setImage(paramImage)
	self._playerAnim8 = 		require ('luascripts/anim8')
	self.playerImage = love.graphics.newImage("images/".. paramImage)
	self._playerG =  self._playerAnim8.newGrid(64, 64, self.playerImage:getWidth(), self.playerImage:getHeight())
end
function Player:getImage()
	return self.playerImage	
end

function Player:getnoWalk()
	return self.noWalk
end

function Player:setFacing(paramFacing)
	self.facing = paramFacing
end
function Player:getFacing()
	return self.facing
end

function Player:setSpeed(paramSpeed)
	self.speed = paramSpeed
end
function Player:getSpeed()
	return self.speed
end

function Player:setX(paramX)
	self.x = paramX
end
function Player:getX()
	return self.x	
end

function Player:setY(paramY)
	self.y = paramY
end
function Player:getY()
	return self.y	
end

function Player:setTileX(paramTileX)
	self.tileX = paramTileX
end
function Player:getTileX()
	return self.tileX
end

function Player:setTileY(paramTileY)
	self.tileY = paramTileY
end
function Player:getTileY()
	return self.tileY
end
--- end of getters and setters ---


function Player:animate(paramAnimate)
	self.animate = paramAnimate
end

--sets player location on the map  
function Player:Location(Px,Py,paramFacing)
	Player:setFacing(paramFacing)
	
	self.tileX = Px
	self.tileY = Py
	--32 is tile size
	self.x = self.tileX * 32
	self.y = self.tileY * 32

	example[num].setCameraWindow( self.x, self.y )
end

function Player:moveTile(parmx,parmy)

	-- Grab the tile
--	 tile = global.layer.tileData(tileX+x, tileY+y)

	-- If the tile doesn't exist or is an obstacle then exit the function
--	if tile == nil then return end
--	if tile.properties.obstacle then return end
	-- Otherwise change the guy's tile
--	self.tileX = self.tileX + parmx
--	self.tileY = self.tileY + parmy
	
	example[num].checkTile( self.tileX, self.tileY  )
end

function Player:checkTile(Parmx,Parmy)
	-- Grab the tile
--	tile = global.layer.tileData(self.tileX + Parmx, self.tileY + Parmy)
	
	-- If the tile doesn't exist or is an obstacle then exit the function
--	if tile == nil then 
--	self.noWalk = true 
--	return 
--	end
	
--	if tile.properties.obstacle then 
--	self.noWalk = true 
--	return 
--	end
	
	-- loop that checks for enemys  on the the tile
--	for i,v in ipairs(global.enemys) do  	
--		if global.enemys[i]:getTileX() == self.tileX + x and global.enemys[i]:getTileY() == self.tileY + y  then
--		self.noWalk = true 
--		return
--		end
--	end
	
	self.noWalk = false
end

--might want to rename this to setAnimation
function Player:setDirection(parmDirection,paramAnimation)
	 
	Player:setFacing(parmDirection)

	
	if paramAnimation =="walk" then
		
	--	self.playerImageName = "male_walkcycle.png"
	--	Player:setImage(self.playerImageName) 
		
		if 	 	self.facing == "up" then	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('2-9,1'), 0.1)
		elseif  self.facing == "left" then	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('2-9,2'), 0.1)
		elseif  self.facing == "down" then	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('2-9,3'), 0.1)
		elseif  self.facing == "right" then	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('2-9,4'), 0.1)
		end
	 end
	
	if paramAnimation =="stand" then
		
	--	self.playerImageName = "male_walkcycle.png"
	--	Player:setImage(self.playerImageName)
		
		if 		self.facing == "up" then	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('1-1,1'), 0.1)
		elseif  self.facing == "left" then 	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('1-1,2'), 0.1)
		elseif  self.facing == "down" then 	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('1-1,3'), 0.1)
		elseif  self.facing == "right" then	self._playerAnimation = self._playerAnim8.newAnimation('loop', self._playerG('1-1,4'), 0.1)
		end
	 end
	 
	 if paramAnimation =="attack" then
		-- need to switch to attack sheet
		--Player.changeImage("male_slash.png")
		self.playerImageName = "male_slash.png"
		Player:setImage(self.playerImageName)
		if 		self.facing == "up" then	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-6,1', '3,1', '2,1', '1,1' ), 0.1)
		elseif  self.facing == "left" then 	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-6,2', '3,2', '2,2', '1,2' ), 0.1)
		elseif  self.facing == "down" then 	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-6,3', '3,3', '2,3', '1,3' ), 0.1)
		elseif  self.facing == "right" then	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-6,4', '3,4', '2,4', '1,4' ), 0.1)
		end
	 end
	 
	 if paramAnimation =="spell" then
		--Player.changeImage("male_spellcast.png")
		self.playerImageName = "male_spellcast.png"
		Player:setImage(self.playerImageName)
		if 		self.facing == "up" then	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-7,1', '4,1', '3,1', '2,1', '1,1' ), 0.1)
		elseif  self.facing == "left" then	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-7,2', '4,2', '3,2', '2,2', '1,2' ), 0.1)
		elseif  self.facing == "down" then	self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-7,3', '4,3', '3,3', '2,3', '1,3' ), 0.1)
		elseif  self.facing == "right" then self._playerAnimation = self._playerAnim8.newAnimation('once', self._playerG('1-7,4', '4,4', '3,4', '2,4', '1,4' ), 0.1)
		end
	 end
end

function Player:keyreleased(k)
  
	if k == "up" then
		self.up = false
		self.animating = false
	end
		
	if k == "down" then
		self.down = false
		self.animating = false
	end	
		
	if k == "left" then
		self.left = false
		self.animating = false
	end
		
	if k == "right" then
		self.right = false
		self.animating = false
	end	
	
end

function Player:keypressed(k)
	
	self.up = false
	self.down = false
	self.left = false
	self.right = false
		
	if self.up == true or self.down == true or self.right == true or self.left == true 	then	
	
	else
		if k == "up" then
			self.up = true
			Player:setDirection("up","walk")
			self.animating = true 
		end
			
		if k == "down" then
			self.down = true
			Player:setDirection("down","walk")
			animate = true
		end	
			
		if k == "left" then
			
			self.left = true
			Player:setDirection("left","walk")
			self.animating = true
			
		end
			
		if k == "right" then
		
			self.right = true
			Player:setDirection("right","walk")
			self.animating = true
			
		end	
	end	

	--testing
	if k == "a" then
		Player:setDirection(self.facing,"attack")
		self.animating = true
		--check if there is something there(enemy) and deal it damage
		Player:attack()
	end	
	if k == "c" then
		Player:setDirection(self.facing,"spell")
		self.animating = true
	end	
	--simple warp function
	if k == "g" then
		Player:Location(5,5,"down")
	end	
	
end

function Player:attack()
	if self.facing == "up" then
		x = 0
		y = -1
	elseif self.facing == "down" then
		x = 0
		y = 1
	elseif self.facing == "left" then
		x = -1
		y = 0
	elseif self.facing == "right" then
		x = 1
		y = 0
	end
	
	for i,v in ipairs(global.enemys) do  	
		if global.enemys[i]:getTileX() == self.tileX+x and global.enemys[i]:getTileY() == self.tileY+y  then
	--	global.temp4 ="Attacking"
		return
		else
	--	global.temp4 ="not Attacking"
		end
	end

end

function Player:update(dt)
	
	if self.up == false and self.down == false and self.right == false and self.left == false 	then	
		if love.keyboard.isDown( "up" ) then
			self.up = true
			Player:setDirection("up","walk")
			self.animating  = true
		elseif love.keyboard.isDown( "down" ) then
			down = true
			Player:setDirection("down","walk")
			self.animating  = true
		elseif love.keyboard.isDown( "left" ) then
			left = true
			Player:setDirection("left","walk")
			self.animating  = true
		elseif love.keyboard.isDown( "right" ) then
			right = true
			Player:setDirection("right","walk")
			self.animating  = true
		end
	end

	local tempY = 0
	local tempX = 0
	
		
		if self.up then	
				
			self.animating  = true
			tempY = self.y - self.speed *dt 
			
			if tempY/global.tileSize <= self.tileY -1 then
				
				Player:checkTile(0,-1)
				
				if self.noWalk then 
					self.animating  = false
				else
					self.y = tempY
					Player:moveTile(0,-1)
				end	
			else
				self.y = tempY
				-- this was moved for camera
				if love.keyboard.isDown("up") and global.ty <= 0 and self.y <= global.mapHeight - (global.tileSize * global.cameraTileLimit ) then 
					camera_up = false
					global.ty = global.ty + self.speed *dt 
					else
					camera_up = true
				end
			end
		end	

		
		if self.down then	
			self.animating  = true
			--check if this will bring us to a no walk tile
			tempY = self.y + self.speed *dt 
			
			if tempY/global.tileSize >= self.tileY  then
				
				Player:checkTile(0,1)
				
				if self.noWalk then 
					self.animating  = false
				else
					self.y = tempY
					Player:moveTile(0,1)
				end	
			else
				self.y = tempY
				-- this was moved for camera
				if love.keyboard.isDown("down") and global.ty >=  -global.mapHeight + love.graphics.getHeight()  and self.y >= 0 + (global.tileSize * global.cameraTileLimit )   then 
					camera_down = false
					global.ty = global.ty - self.speed *dt
				else
					camera_down = true
				end
			end
		end	
		
		
		if self.left then	
			self.animating  = true
			--check if this will bring us to a no walk tile
			tempX = self.x  - self.speed *dt 
			
			if tempX/global.tileSize <= self.tileX  then
				
				Player:checkTile(-1,0)
				
				if self.noWalk then 
					self.animating  = false
				else
					self.x = tempX
					Player:moveTile(-1,0)
				end	
			else
				self.x = tempX
				-- this was moved for camera
				if love.keyboard.isDown("left") and global.tx  <= 0 and self.x <= global.mapWidth - (global.tileSize * global.cameraTileLimit ) then 
					camera_left = false
					global.tx = global.tx + self.speed *dt	
				else
					camera_left = true
				end
			end
		end	
		
		if self.right then	
			self.animating  = true
			tempX = self.x + self.speed *dt 
			
			if tempX/global.tileSize >= self.tileX + 1 then
				
				Player:checkTile(1,0)
				
				if self.noWalk then 
					self.animating  = false
				else
					self.x = tempX
					Player:moveTile(1,0)
				end	
			else
				self.x = tempX
				
				if love.keyboard.isDown("right") and global.tx >=  -global.mapWidth + love.graphics.getWidth() and self.x >= 0 + (global.tileSize * global.cameraTileLimit )  then 
					camera_right = false
					global.tx = global.tx - self.speed *dt 
				else
					camera_right = true
				end
			end
		end	
		
		if self.animating == false then
			Player:setDirection(self.facing,"stand")
		end

	self._playerAnimation:update(dt)
end

function Player:draw()
	--the off set is to correctly place the player
	self._playerAnimation:draw(self.playerImage, self.x -32 , self.y -28 )
end

return Player