-- Our Enemy class
require ('luascripts/middleclass')

 Enemy = class('Enemy')

 function temps()
	 checkForPlayer()
end

 function  initialize(enemyType,enemyImage,enemyWidth,enemyHeight,enemyFacing,enemySpeed,enemyTileX,enemyTileY)
	--public vars
	local cron = require 'luascripts/cron'
	
	local type = enemyType -- can be used later for things like insect,human ect...
	local image = love.graphics.newImage("images/".. enemyImage)
	local imageName = enemyImage
	local width = enemyWidth 
	local height = enemyHeight
	local x = 0
	local y = 0
	local facing = enemyFacing
	local animating = false
	local speed = enemySpeed or 150
	local tileX = enemyTileX or 0
	local tileY = enemyTileY or 0

	local noWalk = false
	 setTileX( tileX)
	 setTileY( tileY)
	 setFacing( facing)
	
	local id =  cron.every(1, temps)
	--private vars
	local _anim8 = require ('luascripts/anim8')
	local _g =   _anim8.newGrid( width,  height,  image:getWidth(),  image:getHeight())
	local _animation =  _anim8.newAnimation('loop',  _g('1-3,1'), 0.1)
end

--- getters and setters ---
 function  setEnemyType(paramType)
	 type = paramType
end
 function  getEnemyType()
	return  type
end

 function  setImage(paramImage)
	 image = love.graphics.newImage("images/".. paramImage)
end
 function  getImage()
	return  image	
end

 function  getnoWalk()
	return  noWalk
end

 function  setFacing(paramFacing)
	 facing = paramFacing
end
 function  getFacing()
	return  facing
end

 function  setSpeed(paramSpeed)
	 speed = paramSpeed
end
 function  getSpeed()
	return  speed
end

 function  setX(paramX)
	 x = paramX
end
 function  getX()
	return  x	
end

 function  setY(paramY)
	 y = paramY
end
 function  getY()
	return  y	
end

 function  setTileX(paramTileX)
	local tileX = paramTileX
end
 function  getTileX()
	return  tileX
end

 function  setTileY(paramTileY)
	 tileY = paramTileY
end
 function  getTileY()
	return  tileY
end
--- end of getters and setters ---

--this will turn animations on or off
 function  animate(paramAnimate)
	 animate = paramAnimate
end

--sets Enemy location on the map  
  function  Location(Px,Py,paramFacing)
	 setFacing(paramFacing)
	
	 tileX = Px
	 tileY = Py
	--32 is tile size
	 x =  tileX * 32
	 y =  tileY * 32
	 setTileX( tileX)
	 setTileY( tileY)
	 setFacing(paramFacing)
end

--moves the enemy to the tile if it can might add a return false so you can error fix
 function  moveTile(x,y)

	-- Grab the tile
	 tile = global.layer.tileData( tileX + x,  tileY + y)

	-- If the tile doesn't exist or is an obstacle then exit the function
	if tile == nil then return end
	if tile.properties.obstacle then return end
	-- Otherwise change the guy's tile
	 tileX =  tileX + x
	 tileY =  tileY + y

end

 function  checkTile(x,y)
	-- Grab the tile
	 tile = global.layer.tileData(tileX+x, tileY+y)
	
	-- If the tile doesn't exist or is an obstacle then exit the function
	if tile == nil then 
	 noWalk = true 
	return 
	end
	
	if tile.properties.obstacle then 
	 noWalk = true 
	return 
	end
	
	 noWalk = false
end

--might want to rename this to setAnimation
 function  setDirection(parmDirection,paramAnimation)
	
	 setFacing(parmDirection)
	if paramAnimation =="walk" then
	--	 setImage(local imageName)
				
		if 	 	 facing == "up" then	 _animation =  _anim8.newAnimation('loop',  _g('1-3,1'), 0.1)
		elseif   facing  == "left" then  _animation =  _anim8.newAnimation('loop',  _g('1-3,2'), 0.1)
		elseif   facing  == "down" then  _animation =  _anim8.newAnimation('loop',  _g('1-3,3'), 0.1)
		elseif   facing  == "right" then  _animation =  _anim8.newAnimation('loop',  _g('1-3,4'), 0.1)
		end
	 end
	if paramAnimation =="stand" then
	--	 setImage(local imageName)
		if 	 	 facing == "up" then	 _animation =  _anim8.newAnimation('loop',  _g('1-3,1'), 0.1)
		elseif   facing  == "left" then  _animation =  _anim8.newAnimation('loop',  _g('1-3,2'), 0.1)
		elseif   facing  == "down" then  _animation =  _anim8.newAnimation('loop',  _g('1-3,3'), 0.1)
		elseif   facing  == "right" then  _animation =  _anim8.newAnimation('loop',  _g('1-3,4'), 0.1)
		end
	 end

		
end

 function  checkForPlayer()
		
	local tempX = 0
	local tempY = 0
	
	if 	 	 getFacing() == "up" then		tempY = -1
	elseif   getFacing()  == "down" then 	tempY = 1
	elseif   getFacing()  == "left" then	tempX = -1
	elseif   getFacing()  == "right" then 	tempX = 1
	end
				
		if	player.getTileX() ==  	 getTileX() + tempX and player.getTileY()  ==   getTileY()+ tempY  then
		--iif	player.getTileX() ==  	local tileX + tempX and player.getTileY()  == local tileY + tempY  then
			global.player_Health = global.player_Health - 1
		else 
			global.player_Health = 10
		end
		
end

 function  update(dt)
	 cron.update(dt)
	--updates the animation
	 _animation:update(dt)
end

 function  draw()
	 _animation:draw( image,  x,  y )
end

return Enemy