-- Our player class
require ('luascripts/middleclass')

Player = class('Player', Entity)

local anim8 = require ('luascripts/anim8')
local image, animation, direction, animate, X, Y , right, left, up, down, speed, tileX, tileY, noWalk

function Player:initialize()
	
	Player.setDirection("up","stand")
	animate = false
	speed = 150
	
	--player starting point
	X = global.startX
	Y = global.startY
	
	tileX = global.startTileX 
	tileY = global.startTileY 
	
	noWalk = false

end

function Player.getnoWalk()
	return noWalk
end

function Player.getDirection()
	return direction
end

function Player.getSpeed()
	return speed
end

function Player.getX()
	return X
end

function Player.getY()
	return Y
end

function Player.getTileX()
	return tileX
end

function Player.getTileY()
	return tileY
end

function Player.changeImage(paramImage)
	image = love.graphics.newImage("images/".. paramImage)
	g = anim8.newGrid(64, 64, image:getWidth(), image:getHeight())
end

function Player.animate(paramAnimate)
	animate = paramAnimate
end

--sets player location on the map  
function Player.Location(Px,Py,facing)
	direction = facing

	tileX = Px
	tileY = Py
	
	X = tileX * 32
	Y = tileY * 32

	example[num].setCameraWindow( X,Y )
end

function Player.moveTile(x,y)
	-- Grab the tile
	 tile = global.layer.tileData(tileX+x, tileY+y)

	-- If the tile doesn't exist or is an obstacle then exit the function
	if tile == nil then return end
	if tile.properties.obstacle then return end
	-- Otherwise change the guy's tile
	tileX = tileX + x
	tileY = tileY + y
	example[num].checkTile( tileX, tileY  )
end

function Player.checkTile(x,y)
	-- Grab the tile
	tile = global.layer.tileData(tileX+x, tileY+y)
	
	
	-- If the tile doesn't exist or is an obstacle then exit the function
	if tile == nil then 
	noWalk = true 
	return 
	end
	
	if tile.properties.obstacle then 
	noWalk = true 
	return 
	end
	
	for i,v in ipairs(global.enemys) do  	
		if global.enemys[i]:getTileX() == tileX+x and global.enemys[i]:getTileY() == tileY+y  then
		noWalk = true 
		return
		end
	end
	
	noWalk = false

end

--might want to rename this to setAnimation
function Player.setDirection(parmDirection,paramAnimation)
	 
	direction = parmDirection
	
	if paramAnimation =="walk" then
		Player.changeImage("male_walkcycle.png")
		if 	 	direction == "up" then	animation = anim8.newAnimation('loop', g('2-9,1'), 0.1)
		
		elseif  direction == "left" then animation = anim8.newAnimation('loop', g('2-9,2'), 0.1)
		
		elseif  direction == "down" then animation = anim8.newAnimation('loop', g('2-9,3'), 0.1)
		
		elseif  direction == "right" then animation = anim8.newAnimation('loop', g('2-9,4'), 0.1)
		
		end
		
	 end
	if paramAnimation =="stand" then
		Player.changeImage("male_walkcycle.png")
		if 	 	direction == "up" then	animation = anim8.newAnimation('loop', g('1-1,1'), 0.1)
		elseif  direction == "left" then animation = anim8.newAnimation('loop', g('1-1,2'), 0.1)
		elseif  direction == "down" then animation = anim8.newAnimation('loop', g('1-1,3'), 0.1)
		elseif  direction == "right" then animation = anim8.newAnimation('loop', g('1-1,4'), 0.1)
		end
	 end
	 if paramAnimation =="attack" then
		-- need to switch to attack sheet
		Player.changeImage("male_slash.png")
		if 	 	direction == "up" then	animation = anim8.newAnimation('once', g('1-6,1', '3,1', '2,1', '1,1' ), 0.1)
		elseif  direction == "left" then animation = anim8.newAnimation('once', g('1-6,2', '3,2', '2,2', '1,2' ), 0.1)
		elseif  direction == "down" then animation = anim8.newAnimation('once', g('1-6,3', '3,3', '2,3', '1,3' ), 0.1)
		elseif  direction == "right" then animation = anim8.newAnimation('once', g('1-6,4', '3,4', '2,4', '1,4' ), 0.1)
		end
	 end
	 
	 if paramAnimation =="spell" then
		Player.changeImage("male_spellcast.png")
		if 	 	direction == "up" then	animation = anim8.newAnimation('once', g('1-7,1', '4,1', '3,1', '2,1', '1,1' ), 0.1)
		elseif  direction == "left" then animation = anim8.newAnimation('once', g('1-7,2', '4,2', '3,2', '2,2', '1,2' ), 0.1)
		elseif  direction == "down" then animation = anim8.newAnimation('once', g('1-7,3', '4,3', '3,3', '2,3', '1,3' ), 0.1)
		elseif  direction == "right" then animation = anim8.newAnimation('once', g('1-7,4', '4,4', '3,4', '2,4', '1,4' ), 0.1)
		end
	 end
end

function Player.keyreleased(k)
  
	if k == "up" then
		up = false
		animate = false
	end
		
	if k == "down" then
		down = false
		animate = false
	end	
		
	if k == "left" then
		left = false
		animate = false
	end
		
	if k == "right" then
		right = false
		animate = false
	end	
	
end

function Player.keypressed(k)
	
	up=false
	down=false
	left=false
	right=false
		
	if up == true or down == true or right == true or left == true 	then	
	
	else
		if k == "up" then
			up = true
			Player.setDirection("up","walk")
			animate = true 
		end
			
		if k == "down" then
			down = true
			Player.setDirection("down","walk")
			animate = true
		end	
			
		if k == "left" then
			
			left = true
			Player.setDirection("left","walk")
			animate = true
			
		end
			
		if k == "right" then
		
			right = true
			Player.setDirection("right","walk")
			animate = true
			
		end	
	end	

	--testing
	if k == "a" then
		Player.setDirection(direction,"attack")
		animate = true
		--check if there is something there(enemy) and deal it damage
		Player.attack()
	end	
	if k == "c" then
		Player.setDirection(direction,"spell")
		animate = true
	end	
	
	if k == "g" then
		Player.Location(5,5,"down")
	end	
	
end

function Player.attack()
	if direction == "up" then
		x = 0
		y = -1
	elseif direction == "down" then
		x = 0
		y = 1
	elseif direction == "left" then
		x = -1
		y = 0
	elseif direction == "right" then
		x = 1
		y = 0
	end
	
	for i,v in ipairs(global.enemys) do  	
		if global.enemys[i]:getTileX() == tileX+x and global.enemys[i]:getTileY() == tileY+y  then
		global.temp4 ="Attacking"
		return
		else
		global.temp4 ="not Attacking"
		end
	end

end

function Player.update(dt)
	
	if up == false and down == false and right == false and left == false 	then	
		if love.keyboard.isDown( "up" ) then
			up = true
			Player.setDirection("up","walk")
			animate = true
		elseif love.keyboard.isDown( "down" ) then
			down = true
			Player.setDirection("down","walk")
			animate = true
		elseif love.keyboard.isDown( "left" ) then
			left = true
			Player.setDirection("left","walk")
			animate = true
		elseif love.keyboard.isDown( "right" ) then
			right = true
			Player.setDirection("right","walk")
			animate = true
		end
	end

	local tempY = 0
	local tempX = 0
	
		
		if up then	
				
			animate = true
			--check if this will bring us to a no walk tile
			tempY = Y  - speed *dt 
			
			if tempY/global.tileSize <= tileY -1 then
				
				Player.checkTile(0,-1)
				
				if noWalk then 
					animate = false
				else
					Y = tempY
					Player.moveTile(0,-1)
				end	
			else
				Y = tempY
				-- this was moved for camera
				if love.keyboard.isDown("up") and global.ty <= 0 and Player.getY() <= global.mapHeight - (global.tileSize * global.cameraTileLimit ) then 
					camera_up = false
					global.ty = global.ty + Player.getSpeed() *dt 
					else
					camera_up = true
				end
			end
		end	

		
		if down then	
			animate = true
			--check if this will bring us to a no walk tile
			tempY = Y  + speed *dt 
			
			if tempY/global.tileSize >= tileY  then
				
				Player.checkTile(0,1)
				
				if noWalk then 
					animate = false
				else
					Y = tempY
					Player.moveTile(0,1)
				end	
			else
				Y = tempY
				-- this was moved for camera
				if love.keyboard.isDown("down") and global.ty >=  -global.mapHeight + love.graphics.getHeight()  and Player.getY() >= 0 + (global.tileSize * global.cameraTileLimit )   then 
					camera_down = false
					global.ty = global.ty - Player.getSpeed() *dt
				else
					camera_down = true
				end
			end
		end	
		
		
		if left then	
			animate = true
			--check if this will bring us to a no walk tile
			tempX = X  - speed *dt 
			
			if tempX/global.tileSize <= tileX  then
				
				Player.checkTile(-1,0)
				
				if noWalk then 
					animate = false
				else
					X = tempX
					Player.moveTile(-1,0)
				end	
			else
				X = tempX
				-- this was moved for camera
				if love.keyboard.isDown("left") and global.tx  <= 0 and Player.getX() <= global.mapWidth - (global.tileSize * global.cameraTileLimit ) then 
					camera_left = false
					global.tx = global.tx + Player.getSpeed() *dt	
				else
					camera_left = true
				end
			end
		end	
		
		if right then	
			animate = true
			tempX = X  + speed *dt 
			
			if tempX/global.tileSize >= tileX + 1 then
				
				Player.checkTile(1,0)
				
				if noWalk then 
					animate = false
				else
					X = tempX
					Player.moveTile(1,0)
				end	
			else
				X = tempX
				
				if love.keyboard.isDown("right") and global.tx >=  -global.mapWidth  +love.graphics.getWidth() and Player.getX() >= 0 + (global.tileSize * global.cameraTileLimit )  then 
					camera_right = false
					global.tx = global.tx - Player.getSpeed() *dt 
				else
					camera_right = true
				end
			end
		end	
		
		if animate == false then
			Player.setDirection(direction,"stand")
		end

	animation:update(dt)
end

function Player.draw()
	--the off set is to correctly place the player
	animation:draw(image, X -32  , Y -28 )
end

return Player