--require ('luascripts/middleclass')
require ('luascripts/Player')
require ('luascripts/GUI')

loader = require("AdvTiledLoader.Loader")
loader.path = "maps/"

-- Some global stuff that the examples use.
global = {}
global.limitDrawing = false		-- If true then the drawing range example is shown
global.benchmark = false		-- If true the map is drawn 20 times instead of 1
global.useBatch = false			-- If true then the layers are rendered with sprite batches
global.tx = 0					-- X translation of the screen
global.ty = 0					-- Y translation of the screen
global.scale = 1				-- Scale of the screen

global.mapWidth = 0 			--Width of the map
global.mapHeight = 0			--Height of the map
global.camera_up = false		--if true camera is at the top and can no longer move up
global.camera_down = false		--if true camera is at the bottom and can no longer move down
global.camera_left = false		--if true camera is at the left and can no longer move left
global.camera_right = false		--if true camera is at the right and can no longer move right

global.startTileX = 2			--the starting tile row
global.startTileY = 5			--the starting tile column

global.tileSize = 32			--the size of the tiles in the maps
global.cameraTileLimit = 10		-- the number of tiles from the edge before the camera moves while the player is moving
global.playerUpdatePaused = false

global.startX = global.tileSize * global.startTileX 				--used to set the players X location when loading the map
global.startY = global.tileSize * global.startTileY 				--used to set the players Y location when loading the map

global.layer = nil 				--must be set to something so nil seemed safe
global.enemys = {}
global.hearts = {}

--temp global vars can be removed any time
global.temp = false
global.temp1 = 0
global.temp2 = ""
global.temp3 = 0
global.temp4 = ""
global.temp5 = ""

--temp for now untill player class is complete
global.player_Health = 9 		--Health of the player
global.player_Water = 10			--Water level of player

player = Player:new("male_walkcycle.png", "male_walkcycle.png",64,64,"up",150,global.startTileX ,global.startTileY) 		--creates the player class
gui = GUI:new()



-- Load the examples
--example = {require("mapscripts/DesertExample"),require("mapscripts/Test")}
example = {require('mapscripts/Outside') , require('mapscripts/Inside2')}		--require("TitleScreen") ,		  
num = 1					-- The map we're currently on

--not currently using FPS stuff
local fps = 0					-- Frames Per Second
local fpsCount = 0				-- FPS count of the current second
local fpsTime = 0				-- Keeps track of the elapsed time


-- Reset the current example 
if example[num].reset then example[num].reset() end



function love.load()

 --  Player.Location(5 ,5 ,"down")
   Player.Location(5 ,5 ,"down")
  
  --creates a image based font to use
   font = love.graphics.newImageFont("images/imagefont.png",
    " abcdefghijklmnopqrstuvwxyz" ..
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
    "123456789.,!?-+/():;%&`'*#=[]\"")
	love.graphics.setFont(font) -- Sets the font to the image based one
	
	-- need to be in a settings menu
	-- success = love.graphics.setMode( 1680, 1050, true, false, 20 )
	-- success = love.graphics.setMode( 1280, 1024, true, false, 20 )
	-- success = love.graphics.setMode( 480, 320, false, false, 20 )
	
--Player.Location(global.startTileX ,global.startTileY,"up")
Player.Location(global.startTileX ,global.startTileY,"up")
--Player.setDirection("up","stand")
Player.setDirection("up","stand")
	
end

function love.keyreleased(k)
	Player.keyreleased(k)
end

--this needs fixed and moved to the player update function so camera window works right
function love.update(dt)
	-- Call update in our example if it is defined
	if example[num].update then example[num].update(dt) end
	--Player.update(dt)
--	cron.update(dt)
	Player.update(dt)
	gui:update(dt)
	
end		



--going to move all key pressed to the player class
function love.keypressed(k)
	
	-- quit
    if k == 'escape' then
        (love.event.push or love.event.quit)('quit')
    end
	
	-- Call keypressed in our example if it is defined
	if example[num].keypressed then example[num].keypressed(k) end
	
	--call keypress in player
	
	--Player.keypressed(k)
	Player.keypressed(k)
end


function love.draw()
	--camera:set()
	-- Draw our map
	example[num].draw()
	
	--gui code will be set up here
--	love.graphics.print("Player Health "..global.player_Health, 20, 20)
--	love.graphics.print("Player Water " ..global.player_Water, 20, 40)

--love.graphics.print("FPS: "..love.timer.getFPS(), 10, 20)
love.graphics.print("This cron job: "..tostring(global.temp5 ), 30, 40)

	gui:draw()
--	camera:unset()
end
function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end