require ('luascripts/middleclass')
require ('luascripts/Player')

-- Our example class
local DesertExample = {}
loader = require("AdvTiledLoader.Loader")
loader.path = "maps/"
map = loader.load("desert.tmx")
local layer = map.tl["Ground"]

local door = map.ol["Object1"]:newObject("door", "Entity",0,0,32,32)
local Guy = map.ol["Object1"]:newObject("Guy", "Entity", 0,0,32,32)

function door.draw()
	love.graphics.drawq(door.image, door.quads[door.facing], door.x, door.y)
end

-- Resets the example
function DesertExample.reset()

--testing to set up doors

	door.tileX = 9	-- The horizontal tile
	door.tileY = 4		-- The vertical tile

	door.facing = "down"	-- The direction our guy is facing
	door.quads = {		-- The frames of the image
			down = 		love.graphics.newQuad(0,0,32,64,256,64),
			downright = love.graphics.newQuad(32,0,32,64,256,64),
			right = 	love.graphics.newQuad(64,0,32,64,256,64),
			upright = 	love.graphics.newQuad(96,0,32,64,256,64),
			up = 		love.graphics.newQuad(128,0,32,64,256,64),
			upleft = 	love.graphics.newQuad(160,0,32,64,256,64),
			left = 		love.graphics.newQuad(192,0,32,64,256,64),
			downleft = 	love.graphics.newQuad(224,0,32,64,256,64),
		}

	door.image = love.graphics.newImage("images/guy.png")
	door.width = door.image:getWidth()
	door.height = door.image:getHeight()
	door:moveTo(door.tileX*map.tileWidth, (door.tileY+1)*map.tileHeight-door.height)
	
	global.layer = layer --this is to  set map to a global var 
	global.mapWidth =  map.width * 32	
	global.mapHeight = map.height* 32	
	
	player.Location(global.startTileX ,global.startTileY ,"down")
	
end

function DesertExample.setCameraWindow(x, y)
	if x >= love.graphics.getWidth()/2 then
		
		if (x + love.graphics.getWidth()/2) * -1 <= -global.mapWidth  +love.graphics.getWidth() then
			global.tx = -global.mapWidth + love.graphics.getWidth()
		else
			global.tx = (x + love.graphics.getWidth()/2) * -1
		end
	else
	 	global.tx = 0
	end
	
	if y >= love.graphics.getHeight()/2 then
		
		if (y + love.graphics.getHeight()/2) * -1 <= -global.mapHeight  +love.graphics.getHeight() then
			global.ty = -global.mapHeight + love.graphics.getHeight()
		else
			global.ty = (y + love.graphics.getHeight()/2) * -1
		end
	else
	 	global.ty = 0
	end
end

--function checks if the player hits any objects
function DesertExample.checkTile(x,y)
	
	--this needs to be on the map script
	if x == door.tileX and y == door.tileY then	
			
		player.Location(0,0,"down")
		num = 2
		global.startTileX = 0			--the starting tile row
		global.startTileY = 0			--the starting tile column	
		example[num].reset()			--loads in the new map
	end
	if x == 6 and y == 5  then	
			
		player.Location(0,0,"down")
		num = 2
		global.startTileX = 0			--the starting tile row
		global.startTileY = 0			--the starting tile column	
		example[num].reset()			--loads in the new map
	end
end


-- Update the display time for the character control instructions
function DesertExample.update(dt)
	
	--this is so the player stays in the render view
	Guy:moveTo(player.getX(), player.getY())

end

function Guy.draw()
	
	--this renders the player in the correct layer
	player.draw()
end

-- Called from love.draw()
function DesertExample.draw()
	
	-- Set sprite batches if they are different than the settings.
	map.useSpriteBatch = global.useBatch

	-- Scale and translate the game screen for map drawing
	local ftx, fty = math.floor(global.tx), math.floor(global.ty)
	love.graphics.push()
	love.graphics.scale(global.scale)
	love.graphics.translate(ftx, fty)

	-- Limit the draw range 
	if global.limitDrawing then 
		map:autoDrawRange(ftx, fty, global.scale, -100) 
	else 
		map:autoDrawRange(ftx, fty, global.scale, 50) 
	end
	
	map:draw() 
		
	-- Reset the scale and translation.
	love.graphics.pop()
end

return DesertExample