require ('luascripts/middleclass')
require ('luascripts/Player')
require ('luascripts/Enemy')


-- Our example class
local Inside = {}



--only the first map needs the loader and loader.path might move this to main
loader = require("AdvTiledLoader.Loader")
loader.path = "maps/"
local map = loader.load("Inside.tmx")
local layer = map.tl["Ground"]

local Guy = map.ol["Object1"]:newObject("Guy", "Entity", 0,0,32,32)

-- Resets the example
function Inside.reset()
	global.layer = layer --this is to  set map to a global var 
	
	global.mapWidth =  map.width * 32	
	global.mapHeight = map.height* 32	
	
	--player:Location(global.startTileX ,global.startTileY ,"down")
end

function Inside.setCameraWindow(x, y)
	if x >= love.graphics.getWidth()/2 then
		
		if (x + love.graphics.getWidth()/2) * -1 <= -global.mapWidth  +love.graphics.getWidth() then
			global.tx = -global.mapWidth + love.graphics.getWidth()
		else
			global.tx = (x + love.graphics.getWidth()/2) * -1
		end
	else
	 	global.tx = 0
	end
	
	if y >= love.graphics.getHeight()/2 then
		
		if (y + love.graphics.getHeight()/2) * -1 <= -global.mapHeight  +love.graphics.getHeight() then
			global.ty = -global.mapHeight + love.graphics.getHeight()
		else
			global.ty = (y + love.graphics.getHeight()/2) * -1
		end
	else
	 	global.ty = 0
	end
end

--function checks if the player hits any objects
function Inside.checkTile(x,y)
	--To exit the house
	if x == 1 and y == 7 then	
		player.Location(13,14,"down")
		num = 1
		global.startTileX = 13			--the starting tile row
		global.startTileY = 14			--the starting tile column	
		example[num].reset()			--loads in the new map
		example[num].setCameraWindow(13, 14)
	end
end


-- Update the display time for the character control instructions
function Inside.update(dt)
	--this is so the player stays in the render view
	Guy:moveTo(player:getX(), player:getY())
end

function Guy.draw()
	--this renders the player in the correct layer
	player:draw()
end

-- Called from love.draw()
function Inside.draw()
	-- Set sprite batches if they are different than the settings.
	map.useSpriteBatch = global.useBatch

	-- Scale and translate the game screen for map drawing
	local ftx, fty = math.floor(global.tx), math.floor(global.ty)
	love.graphics.push()
	love.graphics.scale(global.scale)	
	love.graphics.translate(ftx, fty)

	-- Limit the draw range 
	if global.limitDrawing then 
		map:autoDrawRange(ftx, fty, global.scale, -100) 
	else 
		 map:autoDrawRange(ftx +2, fty+2, global.scale, 0) 
		--map:autoDrawRange(-player.getX(), -player.getY(), global.scale, 100) 

	end
	
	map:draw() 
		
	-- Reset the scale and translation.
	love.graphics.pop()
end


return Inside