require ('luascripts/middleclass')
--require ('luascripts/Player')
require ('luascripts/Enemy')

-- Our example class
local Outside = {}



local map = loader.load("Outside.tmx")
local layer = map.tl["Ground"]

local Guy = map.ol["Object1"]:newObject("Guy", "Entity", 0,0,32,32)

local EnemyBat2 = map.ol["Enemy"]:newObject("EnemyBat2", "Entity", 0,0,32,32)
local bat2 = Enemy:new("batType","bat.png",32,32) 

local EnemyBat = map.ol["Enemy"]:newObject("EnemyBat", "Entity", 0,0,32,32)
local bat = Enemy:new("eyeType","eyeball.png",32,38) 


function EnemyBat2.draw()
	bat2:draw()
end

function EnemyBat.draw()
	bat:draw()
end


-- Resets the example
function Outside.reset()
	
	global.layer = layer --this is to  set map to a global var 
	
	table.insert(global.enemys,bat2)
	table.insert(global.enemys,bat)
	
	global.mapWidth =  map.width * 32	
	global.mapHeight = map.height* 32	
	
	--player:Location(global.startTileX ,global.startTileY ,"down")
	
	bat:Location(4,4,"left")
	bat:setDirection("right","stand")
	
	bat2:Location(6,6,"left")
	bat2:setDirection("down","stand")
end

function Outside.setCameraWindow(x, y)
	if x >= love.graphics.getWidth()/2 then
		
		if (x + love.graphics.getWidth()/2) * -1 <= -global.mapWidth  +love.graphics.getWidth() then
			global.tx = -global.mapWidth + love.graphics.getWidth()
		else
			global.tx = (x + love.graphics.getWidth()/2) * -1
		end
	else
	 	global.tx = 0
	end
	
	if y >= love.graphics.getHeight()/2 then
		
		if (y + love.graphics.getHeight()/2) * -1 <= -global.mapHeight  +love.graphics.getHeight() then
			global.ty = -global.mapHeight + love.graphics.getHeight()
		else
			global.ty = (y + love.graphics.getHeight()/2) * -1
		end
	else
	 	global.ty = 0
	end
end

--function checks if the player hits any objects
function Outside.checkTile(x,y)
	--To enter the house
	if x == 13 and y == 13 then	
		player.Location(13,12,"up")
		num = 2
		global.startTileX = 13			--the starting tile row
		global.startTileY = 12			--the starting tile column	
		example[num].reset()			--loads in the new map
		example[num].setCameraWindow(13, 12)
	end
end


-- Update the display time for the character control instructions
function Outside.update(dt)

	--needs better way to update the instances
	bat:update(dt)
	bat2:update(dt)
		
	EnemyBat:moveTo(bat:getX(), bat:getY())
	EnemyBat2:moveTo(bat2:getX(), bat2:getY())
	--this is so the player stays in the render view
	Guy:moveTo(player:getX(), player:getY())

end

function Guy.draw()
	
	--this renders the player in the correct layer
	player:draw()
end

-- Called from love.draw()
function Outside.draw()
	
	-- Set sprite batches if they are different than the settings.
	map.useSpriteBatch = global.useBatch

	-- Scale and translate the game screen for map drawing
	local ftx, fty = math.floor(global.tx), math.floor(global.ty)
	love.graphics.push()
	love.graphics.scale(global.scale)	
	love.graphics.translate(ftx, fty)

	-- Limit the draw range 
	if global.limitDrawing then 
		map:autoDrawRange(ftx, fty, global.scale, -100) 
	else 
		 map:autoDrawRange(ftx +2, fty+2, global.scale, 0) 
		--map:autoDrawRange(-player.getX(), -player.getY(), global.scale, 100) 
	end
	
	map:draw() 
		
	-- Reset the scale and translation.
	love.graphics.pop()
end

return Outside