--------------testmap use this a a templete for the other maps


--this vars need to be in every map make sure they are local
local Test = {} --this is the class name for the map  i

local map = loader.load("test.tmx")
local layer = map.tl["Ground"]
local Guy = map.ol["Object1"]:newObject("Guy", "Entity", 0,0,32,32) 	--Guy is needed to keep the player in view
----------------------------------------------------------------------------------------------


--declare your objects here like the door example  be sure to also add the draw function or your object wont show
-- Object 1 is the layer name in the tile map 
local door = map.ol["Object1"]:newObject("door", "Entity",0,0,32,32)


-- Resets the example
function Test.reset()
	door.tileX = 10			-- The horizontal tile for the door
	door.tileY = 10			-- The vertical tile for the door
	door.facing = "down"	-- The direction our guy is facing   not needed for a door but left for example
	door.quads = {			-- The frames of the image  not need if you create your own class for the object
			down = 		love.graphics.newQuad(0,0,32,64,256,64),
			downright = love.graphics.newQuad(32,0,32,64,256,64),
			right = 	love.graphics.newQuad(64,0,32,64,256,64),
			upright = 	love.graphics.newQuad(96,0,32,64,256,64),
			up = 		love.graphics.newQuad(128,0,32,64,256,64),
			upleft = 	love.graphics.newQuad(160,0,32,64,256,64),
			left = 		love.graphics.newQuad(192,0,32,64,256,64),
			downleft = 	love.graphics.newQuad(224,0,32,64,256,64),
		}

	door.image = love.graphics.newImage("images/guy.png")
	door.width = door.image:getWidth()
	door.height = door.image:getHeight()
	
	--move the door to the correct tile
	door:moveTo(door.tileX*map.tileWidth, (door.tileY+1)*map.tileHeight-door.height)

	global.layer = nil		--clear the global layer var 
	global.layer = layer 	--this is to  set map to a global var 

	global.mapWidth =  map.width * 32	
	global.mapHeight = map.height* 32	
	
	Test.setCameraWindow(global.startTileX *32, global.startTileY * 32)	
end

function door.draw()
	love.graphics.drawq(door.image, door.quads[door.facing], door.x, door.y)
end

--we could create a actual camera class and move this function and the one in the player class that moves the camera when the player moves
function Test.setCameraWindow(x, y)
	if x >= love.graphics.getWidth()/2 then
		if (x + love.graphics.getWidth()/2) * -1 <= -global.mapWidth  +love.graphics.getWidth() then
			global.tx = -global.mapWidth + love.graphics.getWidth()
		else
			global.tx = (x + love.graphics.getWidth()/2) * -1
		end
	else
	 	global.tx = 0
	end
	
	if y >= love.graphics.getHeight()/2 then
		if (y + love.graphics.getHeight()/2) * -1 <= -global.mapHeight  +love.graphics.getHeight() then
			global.ty = -global.mapHeight + love.graphics.getHeight()
		else
			global.ty = (y + love.graphics.getHeight()/2) * -1
		end
	else
	 	global.ty = 0
	end
end

--function checks if the player hits any objects
function Test.checkTile(x,y)
	
	if x == door.tileX and y == door.tileY then	
			
		player:Location(2,2,"down")
		num = 1
		global.startTileX = 2			--the starting tile row
		global.startTileY = 2			--the starting tile column

		--before doiing the reset we could do some kind of screen animation
		example[num].reset()			--loads in the new map
	end
	
end

-- Update the display time for the character control instructions
function Test.update(dt)
	--this is so the player stays in the render view
	Guy:moveTo(player:getX(), player:getY())
end

function Guy.draw()
	--this renders the player in the correct layer
	player:draw()
end

-- Called from love.draw()
function Test.draw()
	-- Set sprite batches if they are different than the settings.
	map.useSpriteBatch = global.useBatch

	-- Scale and translate the game screen for map drawing
	local ftx, fty = math.floor(global.tx), math.floor(global.ty)
	love.graphics.push()
	love.graphics.scale(global.scale)

	--might need to put this in a if statement if we need to do screen effects
	love.graphics.translate(ftx, fty) 

	-- Limit the draw range 
	if global.limitDrawing then 
		map:autoDrawRange(ftx, fty, global.scale, -100) 
	else 
		map:autoDrawRange(ftx, fty, global.scale, 0) 
	end
	
	map:draw() 
		
	-- Reset the scale and translation.
	love.graphics.pop()
end

return Test